#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include <string.h>

#include "cpp.h"

#define PAL_SIZE 8
#define LIN_SIZE 16
#define OUT_SIZE 7

typedef char one_t[LIN_SIZE*2];

struct one_l {
 one_t oe;
 one_t dat[OUT_SIZE];
 char cnt;
 unsigned oef:1;
 unsigned sel:1;
} pal[PAL_SIZE];

void error(int level, char* mes, ...)
{static char *ma[3]={"Warning","*Error*","*Fatal*"};
 printf("*%s* %s(%d): ",ma[level],in_name,in_line);
 vprintf(mes,...);
 printf("\n\7");
 if (level>=2) exit(1);
}

void do_pragma(char*) {};

FILE* out;
char S[]=" \n\t\f";

void parse_rest(char* line, char* scale)
{char inv=0,*p;
 int num;
 p=strtok(line,S);
 if (!stricmp(p,"true")) memset(scale,0,LIN_SIZE*2); else
 if (!stricmp(p,"false")) memset(scale,1,LIN_SIZE*2); else
 for(;p;p=strtok(NULL,S))
  {if (inv=*p=='~')
    if (!*++p && !(p=strtok(NULL,S)))
     {error(1,"Input number omited"); return;}
   char* p1=strchr(p,'>'); if (p1) *p1=0; // first number-input
   num=atoi(p);
   if (!num || num>LIN_SIZE) error(1,"Wrong input number");
   else scale[inv+num*2-2]=1;}
}

void parse_line(char* line)
{char* dat=strchr(line,'='),*p;
 if (!dat) {error(1,"Sign '=' omited"); return;}
 *dat++=0;
 p=strtok(line,S);
 if (!p) {error(1,"Output line number omited"); return;}
 char *p1=strchr(p,'>'); if (p1) p=p1+1; // second number-output
 int num=atoi(p);
 if (num<=0 || num>PAL_SIZE) {error(1,"Wrong output line number"); return;}
 num--;
 if (p=strtok(NULL,S))
  {if (stricmp(p,"cs")) error(1,"Unknown output line tag '%s'",p); else
   if (pal[num].oef) error(1,"OE already defined"); else
    {pal[num].oef=1; pal[num].sel=1; parse_rest(dat,pal[num].oe);}}
 else if (pal[num].cnt>=OUT_SIZE) error(1,"No more terms for %d output",num);
 else {pal[num].sel=1; parse_rest(dat,pal[num].dat[pal[num].cnt++]);}
}

void W(char b, int cnt=1)
{errno=0;
 while(cnt--)
  if (putc(b,out)==EOF) error(2,"Unable to write: %s",sys_errlist[errno]);
}

void wr_str(char* s)
{int i; for(i=0;i<LIN_SIZE*2;++i) W(*s++);}

void gen_out(void)
{int i,j;
 for(i=0;i<PAL_SIZE;++i)
  if (!pal[i].sel) W(1,LIN_SIZE*2*(OUT_SIZE+1)); else
   {if (pal[i].oef) wr_str(pal[i].oe); else W(0,LIN_SIZE*2);
    for(j=0;j<pal[i].cnt;++j) wr_str(pal[i].dat[j]);
    for(;j<OUT_SIZE;++j) W(1,LIN_SIZE*2);}
}

char *in_n,*out_n;
main()
{for(int i=1;i<_argc;++i)
  if(*(int*)_argv[i]=='-I' || *(int*)_argv[i]=='/I') src_path=_argv[i]+2; else
  if (!in_n)  in_n=_argv[i];  else
  if (!out_n) out_n=_argv[i]; else
  goto err;
 if (!out_n)
  {err: puts("Usage: prom [-I<path>] <in file> <out file>"); return -1;}
 if (prep_pp(in_n)) error(2,"Can't open %s",in_n);
 out=fopen(out_n,"wb");
 if (!out) error(2,"Can't create %s",out_n);
 char b[1024];
 while(!get_line(b,1023)) parse_line(b);
 past_pp();
 gen_out();
 fclose(out);
}
