#include <stdio.h>
#include <io.h>
#include <stdlib.h>
#include <string.h>
#include <dos.h>

#include "cpp.h"

struct one_gate {
 char direct;
 char invert;
};

typedef one_gate line_gate[16];

typedef line_gate pal_file[64];

pal_file PAL_FILE;

void load_pf(char* nm)
{FILE * f=fopen(nm,"rb");
 if (!f) error(2,"Can't open input file %s",nm);
 long l;
 if ((l=filelength(fileno(f)))<sizeof PAL_FILE)
  error(2,"File %s too short",nm);
 if (l>sizeof PAL_FILE) error(0,"File %s too long. Extra data ignored.",nm);
 if (fread(PAL_FILE,sizeof PAL_FILE, 1, f)!=1)
    error(2,"Can't read input file!!!");
 fclose(f);
}

char *inputs[16];
char *outputs[8];

void all_pps(char* name, char* body, int parn)
{if (parn) return;
 char* p;
 unsigned i=0,o=0;
 i=strtol(body,&p,10);
 if (i>16) return;
 if (*p&&*p!='>') return;
 if (*p)
  {o=strtol(p+1,&p,10);
   if (*p || o>8) return;}
 if (i && !inputs[i-1])  inputs[i-1]=strdup(name);
 if (o && !outputs[o-1]) outputs[o-1]=strdup(name);
}

void pp_load(char* nm)
{if (prep_pp(nm)) {error(1,"Can't open define file %s",nm); return;}
 char b[1024];
 while(!get_line(b,1023));
 all_defs(all_pps);
 past_pp();
}

FILE* out;
void W(char* s, ...)
{if (vfprintf(out,s,...)==EOF) error(1,"Error writing output file");
}

char* O(int n)
{if (outputs[n]) return outputs[n];
 static char s[30];
 return itoa(n+1,s,10);
}

char* I(int n)
{if (inputs[n]) return inputs[n];
 static char s[30];
 return itoa(n+1,s,10);
}

int tst_lg(line_gate p)
{int s=0;
 for(int i=0;i<16;++i) s+=(p[i].direct&1) + (p[i].invert&1);
 return s;
}

void gen_outs(line_gate p)
{for(int i=0;i<16;++i)
  {if (p[i].direct) W(" %s",I(i));
   if (p[i].invert) W(" ~%s",I(i));}
 W("\n");
}

void gen_out(char* nm, char *pp)
{if (nm)
  {if (!(out=fopen(nm,"wt")))
    error(2,"Can't create output file %s",nm);}
 else out=stdout;
 if (pp) W("#include \"%s\"\n\n",pp);
 for(int outs=0;outs<8;++outs)
  {line_gate * lg=&PAL_FILE[outs*8];
   int f=0,ff,j;
   for(int i=0;i<8;++i)
    switch(tst_lg(lg[i]))
     {case 0: if (!i)
         {for(ff=0,j=1;j<8;++j) ff+=tst_lg(lg[j])!=32; if (ff) break;}
        f=1; W("%s%s = true\n",O(outs),i?"":" cs"); break;
      case 32: if (i) break;
        for(ff=0,j=1;j<8;++j) ff+=tst_lg(lg[j])==32; if (ff!=8) break;
        f=1; W("%s%s = false\n",O(outs),i?"":" cs"); break;
      default: f=1; W("%s%s =",O(outs),i?"":" cs"); gen_outs(lg[i]);}
   if (f) W("\n");}
 fclose(out);
}

main()
{char *p=NULL;
 if (_argc==1) {puts("Usage: unprom [-<header>] <input> [<output>]"); return 0;}
 if (_argv[1][0]=='-') {pp_load(p=_argv[1]+1); ++_argv; --_argc;}
 if (_argc==1) {puts("Usage: unprom [-<header>] <input> [<output>]"); return 0;}
 load_pf(_argv[1]);
 gen_out(_argv[2],p);
 for(int i=0;i<16;++i) if (inputs[i]) free(inputs[i]);
 for(i=0;i<8 ;++i) if (outputs[i]) free(outputs[i]);
 return 0;
}

void do_pragma(char*) {};

void error(int level, char* mes, ...)
{static char *ma[3]={"Warning","*Error*","*Fatal*"};
 printf("*%s* %s(%d): ",ma[level],in_name,in_line);
 vprintf(mes,...);
 printf("\n\7");
 if (level>=2) exit(1);
}
